#include "gbox_applet.h"
#include "gbox_mailbox.h"
#include <stdlib.h>
#include <string.h>

Icons     current_icons;
GtkWidget *mailbox;
GtkWidget *nickname;
GtkWidget *interval;
GtkWidget *clist;   
GtkWidget *btn_prio;
GtkWidget *dlg;
GtkWidget *prop_box;
GtkWidget *mailprog;
GtkWidget *chk_beep;
GtkWidget *chk_relief;
GtkWidget *chk_tooltip;
GtkWidget *chk_show_in_menu;
GtkWidget *cbo_menu_type;
GtkWidget *cbo_tooltip_type;
GtkWidget *cbo_tooltip_pos;
GtkWidget *btn_new_mailbox;
GtkWidget *box_add, *box_remove, *box_edit, *box_copy;
GtkWidget *btn_move_up, *btn_move_down;
GtkWidget *file_selector;
GtkWidget *icon_selector[COUNT_PRIORITY + 1];
int       current_row;
int       dlg_mailbox_type;
int       edit_mode;
gchar     *old_mailbox_file;
MailBoxList *copy_list;

gchar *tooltip_types[] = { N_("x/y mailboxes contain new mail"), 
			   N_("sorted by priorities"), 
			   N_("each mailbox separate"),
			   N_("each mailbox with new mail")};

gchar *tooltip_pos[] = {N_("above"),
			N_("to the left"),
			N_("below"),
			N_("to the right")};

gchar *menu_types[] = {N_("<subject>"),
		       N_("<sender>"),
		       N_("<sender> -- <subject>")};

extern MailBox     *exchange_mb;
extern MailBoxList *mb_list;
extern GboxApplet  *applet;

void
store_mailbox(GtkFileSelection *selector, gpointer user_data)
{
    gtk_entry_set_text(GTK_ENTRY(mailbox), 
		       gtk_file_selection_get_filename (GTK_FILE_SELECTION(file_selector)));
}

void
select_mailbox_cb(GtkWidget* w, gpointer cbdata)
{
    file_selector = gtk_file_selection_new(_("Select a mailbox"));
    
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
			"clicked", GTK_SIGNAL_FUNC (store_mailbox), NULL);

    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
			       "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			       (gpointer) file_selector);

    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->cancel_button),
			       "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			       (gpointer) file_selector);
    
    gtk_widget_show (file_selector);
}

void
store_mailprog(GtkFileSelection *selector, gpointer user_data)
{
    gtk_entry_set_text(GTK_ENTRY(mailprog), 
		       gtk_file_selection_get_filename (GTK_FILE_SELECTION(file_selector)));
}

void
select_mailprog(GtkWidget* w, gpointer cbdata)
{
    file_selector = gtk_file_selection_new(_("Select a mail-client"));
    
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
			"clicked", GTK_SIGNAL_FUNC (store_mailprog), NULL);

    /* Ensure that the dialog box is destroyed when the user clicks a button. */
    
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
			       "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			       (gpointer) file_selector);

    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->cancel_button),
			       "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			       (gpointer) file_selector);
    
    /* Display that dialog */
    
    gtk_widget_show (file_selector);
}

static gint
box_select_cb(GtkWidget* w, gint row, gint column, 
			    GdkEventButton* event, gpointer cbdata)
{
  current_row = row;
  if (!edit_mode) {
    gtk_widget_set_sensitive(GTK_WIDGET(box_edit), (row != -1?TRUE:FALSE) );
    gtk_widget_set_sensitive(GTK_WIDGET(box_remove), (row != -1?TRUE:FALSE) );
    gtk_widget_set_sensitive(GTK_WIDGET(box_copy), (row != -1?TRUE:FALSE) );
    gtk_widget_set_sensitive(GTK_WIDGET(btn_move_up), (row != -1 && row != 0?TRUE:FALSE) );
    gtk_widget_set_sensitive(GTK_WIDGET(btn_move_down), 
			     (row != -1 && row != (gbox_mailbox_list_count(copy_list) - 1)?TRUE:FALSE));
    
  }

  return 0;
}

static gint
ok_cb(GtkWidget* w, gpointer cbdata)
{
  gchar   *tmp;
  gchar   *row[3];
  gchar   num[64];
  MailBox *box;
  
  edit_mode = FALSE;
  
  tmp = gtk_editable_get_chars(GTK_EDITABLE(mailbox), 0, -1);
  if (!strlen(tmp)) {
    gnome_error_dialog(_("You have to enter a filename!"));
    return 0;
  }
  exchange_mb->mailfile = g_strdup(tmp);
  g_free(tmp);

  tmp = gtk_editable_get_chars(GTK_EDITABLE(nickname), 0, -1);
  if (!strlen(tmp)) {
    gnome_error_dialog(_("It is better to enter a nickname!"));
    return 0;
  }
  exchange_mb->nickname = g_strdup(tmp);
  g_free(tmp);

  tmp = gtk_editable_get_chars(GTK_EDITABLE(interval), 0, -1);
  if (!strlen(tmp)) {
    gnome_error_dialog(_("You have to enter an interval!"));
    return 0;
  }
  exchange_mb->interval = atoi(tmp) * 1000;
  exchange_mb->show_in_menu = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_show_in_menu));

  if (exchange_mb->priority != gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(btn_prio))) {
/*      printf("priority changed!\n"); */
    if (exchange_mb->mail_count) {
/*        printf("priority changing!\n"); */
      copy_list->new_count[exchange_mb->priority]--;
      copy_list->new_count[gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(btn_prio))]++;
    }
  }
  exchange_mb->priority = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(btn_prio));

  g_free(tmp);

  tmp = gtk_editable_get_chars(GTK_EDITABLE(GTK_COMBO(cbo_menu_type)->entry), 0, -1);
  if (!strcmp(_(menu_types[0]), tmp))
    exchange_mb->menu_type = 0;
  else
    if (!strcmp(_(menu_types[1]), tmp))
      exchange_mb->menu_type = 1;
    else
      if (!strcmp(_(menu_types[2]), tmp))
	exchange_mb->menu_type = 2;

  g_free(tmp);
    
  if (dlg_mailbox_type) {
    box = gbox_mailbox_new(exchange_mb->mailfile, exchange_mb->nickname, 
			   exchange_mb->interval, exchange_mb->priority, 
			   exchange_mb->show_in_menu, exchange_mb->menu_type);
    gbox_mailbox_add(copy_list, box);
  } else
    gbox_mailbox_change(copy_list, old_mailbox_file, exchange_mb);

  g_free(old_mailbox_file);
  
  row[0] = exchange_mb->nickname;
  g_snprintf(num, sizeof(num), "%d", exchange_mb->interval / 1000);
  row[1] = g_strdup(num);
  g_snprintf(num, sizeof(num), "%d", exchange_mb->priority);
  row[2] = g_strdup(num);
  
  if (!dlg_mailbox_type) {
    gtk_clist_set_text(GTK_CLIST(clist), current_row, 0, row[0]);
    gtk_clist_set_text(GTK_CLIST(clist), current_row, 1, row[1]);
    gtk_clist_set_text(GTK_CLIST(clist), current_row, 2, row[2]);
  } else 
    gtk_clist_append(GTK_CLIST(clist), row);
  
  gtk_widget_destroy(GTK_WIDGET(cbdata));
  gnome_property_box_changed(GNOME_PROPERTY_BOX(prop_box));
  
  gtk_widget_set_sensitive(GTK_WIDGET(box_add), TRUE);
  gtk_widget_set_sensitive(GTK_WIDGET(box_edit), (current_row != -1?TRUE:FALSE) );
  gtk_widget_set_sensitive(GTK_WIDGET(box_remove), (current_row != -1?TRUE:FALSE) );
  gtk_widget_set_sensitive(GTK_WIDGET(box_copy), (current_row != -1?TRUE:FALSE) );
  gtk_widget_set_sensitive(GTK_WIDGET(btn_move_up), (current_row != -1?TRUE:FALSE) );
  gtk_widget_set_sensitive(GTK_WIDGET(btn_move_down), (current_row != -1?TRUE:FALSE) );

  if (exchange_mb) {
    g_free(exchange_mb->mailfile);
    g_free(exchange_mb->nickname); 
  }

  return 0;
}

static gint
cancel_cb(GtkWidget* w, gpointer cbdata)
{
  gtk_widget_destroy(GTK_WIDGET(cbdata));

  edit_mode = FALSE;
  gtk_widget_set_sensitive(GTK_WIDGET(box_add), TRUE);
  gtk_widget_set_sensitive(GTK_WIDGET(box_edit), (current_row != -1?TRUE:FALSE) );
  gtk_widget_set_sensitive(GTK_WIDGET(box_remove), (current_row != -1?TRUE:FALSE) );
  gtk_widget_set_sensitive(GTK_WIDGET(box_copy), (current_row != -1?TRUE:FALSE) );
  gtk_widget_set_sensitive(GTK_WIDGET(btn_move_up), (current_row != -1?TRUE:FALSE) );
  gtk_widget_set_sensitive(GTK_WIDGET(btn_move_down), (current_row != -1?TRUE:FALSE) );

  return 0;
}

void
menu_changed(GtkWidget* w, gpointer cbdata)
{
  gtk_widget_set_sensitive(GTK_WIDGET(cbo_menu_type), gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_show_in_menu)));
/*    printf("ENTRY: %u\n", GTK_LIST(GTK_COMBO(cbo_tooltip_type)->list)->drag_pos); */  
}

void
show_box_dialog()
{
  GtkWidget *table;
  GtkWidget *label;
  gchar     buf[32];
  GtkWidget *ok;
  GtkWidget *box;
  GtkWidget *cancel;
  GtkObject *spin_conf;
  gchar     *text[3];
  MailBox   *tmp_mailbox;
  GList     *list = NULL;

  text[0] = text[1] = text[3] = NULL;
  
  edit_mode = TRUE;
  
  if (!dlg_mailbox_type) {
    tmp_mailbox = gbox_mailbox_get(copy_list, current_row);
    
    exchange_mb->mailfile = g_strdup(tmp_mailbox->mailfile);
    exchange_mb->nickname = g_strdup(tmp_mailbox->nickname);
    exchange_mb->interval = tmp_mailbox->interval;
    exchange_mb->priority = tmp_mailbox->priority;
    exchange_mb->mail_count = tmp_mailbox->mail_count;
    exchange_mb->show_in_menu = tmp_mailbox->show_in_menu;
    exchange_mb->menu_type = tmp_mailbox->menu_type;
  }

  dlg = gtk_dialog_new ();
  
  if (!dlg_mailbox_type)
    gtk_window_set_title(GTK_WINDOW(dlg), _("Edit mailbox"));
  else {
    if (dlg_mailbox_type == 1)
      gtk_window_set_title(GTK_WINDOW(dlg), _("Add mailbox"));
    else
      gtk_window_set_title(GTK_WINDOW(dlg), _("Copy mailbox"));
  }
  
  
  gtk_widget_set_sensitive(GTK_WIDGET(box_add), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(box_edit), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(box_remove), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(box_copy), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(btn_move_up), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(btn_move_down), FALSE);
  gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
  
  table = gtk_table_new(6, 3, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table), GNOME_PAD_SMALL);
  
  label = gtk_label_new(_("Mailbox:"));
  gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 0, 1, 
		   GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND | GTK_FILL, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
    box = gtk_hbox_new(FALSE, 0);
  
  mailbox = gtk_entry_new();
  
  old_mailbox_file = g_strdup(exchange_mb->mailfile);
  
  if ((!dlg_mailbox_type || dlg_mailbox_type == 2) && exchange_mb)
    gtk_entry_set_text(GTK_ENTRY(mailbox), exchange_mb->mailfile);
  
  btn_new_mailbox = gtk_button_new_with_label(_("..."));

  gtk_box_pack_start(GTK_BOX(box), mailbox, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(box), btn_new_mailbox, FALSE, FALSE, GNOME_PAD_SMALL);

  gtk_table_attach(GTK_TABLE(table), box, 1, 4, 0, 1,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);    
  
  /* Nickname for mailbox*/

  label = gtk_label_new(_("Nickname:"));
  gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 1, 2, 
		   GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND | GTK_FILL, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  nickname = gtk_entry_new();
  /*   gtk_entry_set_editable(GTK_ENTRY(mailbox), FALSE); */
  gtk_table_attach(GTK_TABLE(table), nickname, 1, 3, 1, 2,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  /*  old_mailbox_file = g_strdup(exchange_mb->nickname);*/
  
  if ((!dlg_mailbox_type || dlg_mailbox_type == 2) && exchange_mb)
    gtk_entry_set_text(GTK_ENTRY(nickname), exchange_mb->nickname);

  /* second row */
  
  label = gtk_label_new(_("Interval:"));
  gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 2, 3, 
		   GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND | GTK_FILL, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  box = gtk_hbox_new(FALSE, 0);
  interval = gtk_entry_new();
  label = gtk_label_new(_("sec."));
  gtk_box_pack_start(GTK_BOX(box), interval, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, GNOME_PAD_SMALL);
  
  /*   gtk_entry_set_editable(GTK_ENTRY(interval), FALSE); */
  gtk_table_attach(GTK_TABLE(table), box, 1, 2, 2, 3,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  if ((!dlg_mailbox_type || dlg_mailbox_type == 2) && exchange_mb) {
    g_snprintf(buf, sizeof(buf), "%d", exchange_mb->interval / 1000);
    gtk_entry_set_text(GTK_ENTRY(interval), buf);
  }
  
  /* third row */
  label = gtk_label_new(_("Priority:"));
  gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 3, 4, 
		   GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND | GTK_FILL, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  spin_conf = gtk_adjustment_new(0, 0, COUNT_PRIORITY - 1, 1.0, 1.0, 1.0);
  btn_prio = gtk_spin_button_new(GTK_ADJUSTMENT(spin_conf), 1.0, 1);
  gtk_spin_button_set_digits(GTK_SPIN_BUTTON(btn_prio), 0);
  gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(btn_prio), TRUE);
  gtk_spin_button_set_snap_to_ticks(GTK_SPIN_BUTTON(btn_prio), TRUE);
  /*  gtk_widget_set_sensitive(GTK_WIDGET(&(GTK_SPIN_BUTTON(btn_prio)->entry)), FALSE);*/

  
  gtk_table_attach(GTK_TABLE(table), btn_prio, 1, 2, 3, 4,
		   GTK_FILL, 
		   GTK_FILL, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  if ((!dlg_mailbox_type || dlg_mailbox_type == 2) && exchange_mb)
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(btn_prio), (float)exchange_mb->priority);
  


  chk_show_in_menu = gtk_check_button_new_with_label(_("show mailbox in menu"));
/*    gtk_misc_set_alignment(GTK_MISC(chk_show_in_menu), 0.0, 0.5); */
  if ((!dlg_mailbox_type || dlg_mailbox_type == 2) && exchange_mb)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chk_show_in_menu), exchange_mb->show_in_menu);

  gtk_table_attach(GTK_TABLE(table), chk_show_in_menu, 0, 2, 4, 5,
		   GTK_EXPAND | GTK_FILL,
		   GTK_EXPAND | GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);

  cbo_menu_type = gtk_combo_new();
  g_list_free(list); list = NULL;
  
  list = g_list_append(list,_(menu_types[0])); 
  list = g_list_append(list,_(menu_types[1]));  
  list = g_list_append(list,_(menu_types[2]));

  gtk_combo_set_popdown_strings(GTK_COMBO(cbo_menu_type), list); 
  gtk_combo_set_use_arrows(GTK_COMBO(cbo_menu_type), 3);
  /*  gtk_combo_set_value_in_list(GTK_COMBO(cbo_tooltip_type), */

  if ((!dlg_mailbox_type || dlg_mailbox_type == 2) && exchange_mb)
    switch (exchange_mb->menu_type) {
    case 0:
      gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_menu_type)->entry), _(menu_types[0])); break;
    case 1:
      gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_menu_type)->entry), _(menu_types[1])); break;
    case 2:
      gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_menu_type)->entry), _(menu_types[2]));
    }

  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(cbo_menu_type)->entry), FALSE); 
  
  gtk_widget_set_sensitive(GTK_WIDGET(cbo_menu_type), 
			   gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_show_in_menu)));

  gtk_table_attach(GTK_TABLE(table), cbo_menu_type, 0, 2, 5, 6,
		   GTK_EXPAND | GTK_FILL,
		   GTK_EXPAND | GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);

  gtk_signal_connect_object_while_alive (GTK_OBJECT (chk_show_in_menu), "toggled",
					 GTK_SIGNAL_FUNC(menu_changed), 
					 GTK_OBJECT(prop_box));

  /* buttons */
  ok = gnome_stock_button(GNOME_STOCK_BUTTON_OK);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dlg)->action_area), ok);
  
  cancel = gnome_stock_button(GNOME_STOCK_BUTTON_CANCEL);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dlg)->action_area), cancel);
  
  gtk_widget_show(GTK_WIDGET(ok));
  gtk_widget_show(GTK_WIDGET(cancel));
  
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dlg)->vbox), table);
  gtk_widget_show_all(table);
  
  gtk_signal_connect(GTK_OBJECT(btn_new_mailbox), "clicked",
		     GTK_SIGNAL_FUNC(select_mailbox_cb), dlg);
  
  gtk_signal_connect(GTK_OBJECT(ok), "clicked",
		     GTK_SIGNAL_FUNC(ok_cb), dlg);
  
  gtk_signal_connect(GTK_OBJECT(dlg), "destroy",
		     GTK_SIGNAL_FUNC(cancel_cb), dlg);

  gtk_signal_connect(GTK_OBJECT(cancel), "clicked",
		     GTK_SIGNAL_FUNC(cancel_cb), dlg);
  
  gtk_widget_show(dlg);
}

void
move_down_cb(GtkWidget* w, gpointer cbdata)
{
  char **row;
  
  gnome_property_box_changed(GNOME_PROPERTY_BOX(prop_box));
  row = gbox_mailbox_row_get(gbox_mailbox_get(copy_list, current_row));
  gbox_mailbox_list_move(copy_list, current_row, 1);
  gtk_clist_remove(GTK_CLIST(clist), current_row);

  gtk_clist_insert(GTK_CLIST(clist), current_row + 1, row);
  gtk_clist_select_row(GTK_CLIST(clist), current_row + 1, 0);
  gbox_mailbox_row_free(row);
}

void
move_up_cb(GtkWidget* w, gpointer cbdata)
{
  char **row;

  gnome_property_box_changed(GNOME_PROPERTY_BOX(prop_box));
  row = gbox_mailbox_row_get(gbox_mailbox_get(copy_list, current_row));
  gbox_mailbox_list_move(copy_list, current_row, -1);
  gtk_clist_remove(GTK_CLIST(clist), current_row);

  gtk_clist_insert(GTK_CLIST(clist), current_row - 1, row);
  gtk_clist_select_row(GTK_CLIST(clist), current_row - 1, 0);
  gbox_mailbox_row_free(row);
}
      
void
add_box_cb(GtkWidget* w, gpointer cbdata)
{
  dlg_mailbox_type = 1;
  show_box_dialog();
}

void
edit_box_cb(GtkWidget* w, gpointer cbdata)
{
  dlg_mailbox_type = 0;
  show_box_dialog();  
}

void
remove_or_not(gint reply,gpointer data)
{
  if (!reply) { 
    gbox_mailbox_remove_by_index(copy_list, current_row);
    update_tooltip();
    gtk_clist_remove(GTK_CLIST(clist), current_row);
    gtk_widget_set_sensitive(GTK_WIDGET(box_edit), FALSE );
    gtk_widget_set_sensitive(GTK_WIDGET(box_remove), FALSE );
    current_row = -1;
		gnome_property_box_changed(GNOME_PROPERTY_BOX(prop_box));
  }
}

void
remove_box_cb(GtkWidget* w, gpointer cbdata)
{
  gchar *text[3];
  gchar *msg;
  text[0] = text[1] = text[3] = NULL;
  
  msg = (gchar *)g_malloc(512);
  
  gtk_clist_get_text(GTK_CLIST(clist), current_row, 0, text);
  g_snprintf(msg, sizeof(msg), _("Do you really want to remove the mailbox '%s'?"), text[0]);
  gnome_question_dialog_modal(msg, remove_or_not, text[0]);
  g_free(msg);
}

void
copy_box_cb(GtkWidget* w, gpointer cbdata)
{
  MailBox * mailbox = gbox_mailbox_get(copy_list, current_row);
  
  dlg_mailbox_type = 2;
  exchange_mb->mailfile = g_strdup(mailbox->mailfile);
  exchange_mb->nickname = g_strdup(mailbox->nickname);
  exchange_mb->interval = mailbox->interval;
  exchange_mb->priority = mailbox->priority;  
  show_box_dialog();  
}


void
text_changed(GtkWidget* w, gpointer cbdata)
{
  gnome_property_box_changed(GNOME_PROPERTY_BOX(prop_box));
  gtk_widget_set_sensitive(GTK_WIDGET(cbo_tooltip_type), gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_tooltip)));
  gtk_widget_set_sensitive(GTK_WIDGET(cbo_tooltip_pos), gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_tooltip)));
/*    printf("ENTRY: %u\n", GTK_LIST(GTK_COMBO(cbo_tooltip_type)->list)->drag_pos); */  
}


void
close_prop_cb(GtkWidget* propertybox, gint page_num, gpointer data)
{
  int i;
  
	applet->prop_box_active = FALSE;
	start_timer();
  g_free(current_icons.file_no_mail);
  for (i = 0; i < COUNT_PRIORITY; i++)
    g_free(current_icons.file_new_mail[i]);

  gbox_mailbox_list_free(copy_list);
  copy_list = NULL;
  
  gtk_widget_destroy(prop_box);
}

void
apply_prop_cb(GtkWidget* propertybox, gint page_num, gpointer data)
{
  gchar         *tmp;
  int           i;
  
/*    printf("Apply %d\n", page_num); */
  
  switch (page_num) {
  case 0:
    tmp = gtk_editable_get_chars(GTK_EDITABLE(mailprog), 0, -1);
    if (applet->mail_prog) g_free(applet->mail_prog);
    applet->mail_prog = g_strdup(tmp);
    g_free(tmp);
    mb_list = gbox_mailbox_list_copy(copy_list);
    break;
  case 1:
    g_free(applet->no_mail_pix);
    
    applet->no_mail_pix = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(current_icons.no_mail));
    load_image(applet->no_mail_pix, &applet->no_email_image,
	       &applet->no_email_pixmap, &applet->no_email_mask);
    for (i = 0; i < COUNT_PRIORITY; i++) {
      g_free(applet->new_mail_pix[i]);
      applet->new_mail_pix[i] = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(current_icons.new_mail[i]));
    }
  case 2:
    applet->style_beep = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_beep));
    applet->style_relief = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_relief));
    if (applet->style_relief)
      gtk_button_set_relief(GTK_BUTTON(applet->main_button), GTK_RELIEF_NONE);
    else
      gtk_button_set_relief(GTK_BUTTON(applet->main_button), GTK_RELIEF_NORMAL);

    applet->show_tooltip = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_tooltip));
    tmp = gtk_editable_get_chars(GTK_EDITABLE(GTK_COMBO(cbo_tooltip_type)->entry), 0, -1);
    if (!strcmp(_(tooltip_types[0]), tmp))
      applet->style_tooltip = 0;
    else
      if (!strcmp(_(tooltip_types[1]), tmp))
      applet->style_tooltip = 1;
    else
      if (!strcmp(_(tooltip_types[2]), tmp))
      applet->style_tooltip = 2;
    else
      if (!strcmp(_(tooltip_types[3]), tmp))
      applet->style_tooltip = 3;

    g_free(tmp);

    tmp = gtk_editable_get_chars(GTK_EDITABLE(GTK_COMBO(cbo_tooltip_pos)->entry), 0, -1);
    if (!strcmp(_(tooltip_pos[0]), tmp))
      applet->pos_tooltip = 0;
    else
      if (!strcmp(_(tooltip_pos[1]), tmp))
      applet->pos_tooltip = 1;
    else
      if (!strcmp(_(tooltip_pos[2]), tmp))
      applet->pos_tooltip = 2;
    else
      if (!strcmp(tooltip_pos[3], tmp))
      applet->pos_tooltip = 3;

    g_free(tmp);
  }
}

GtkWidget *
create_page_global()
{
  int        i;
  MailBox    *walk = copy_list->first_mb;
  gchar      buf[32];
  gchar* col_titles[] = {_("nickname"), _("interval"), _("priority")};
  GtkWidget* table;
  GtkWidget* label;
  /*  GtkWidget* btn_mailprog;*/
  GtkWidget* scroll_win;
  gchar      *row[3];
  
  current_row = -1;
  
  table = gtk_table_new(8, 5, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table), GNOME_PAD_SMALL);
  
  /* third line */
  label = gtk_label_new(_("Mailreader:"));
  gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 2, 3, 
		   GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND | GTK_FILL, 
		   0, 0);
  
  mailprog = gtk_entry_new();
  /*   gtk_entry_set_editable(GTK_ENTRY(mailprog), FALSE); */
  gtk_table_attach(GTK_TABLE(table), mailprog, 1, 4, 2, 3,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   0, GNOME_PAD_SMALL);
  gtk_entry_set_text(GTK_ENTRY(mailprog), applet->mail_prog);
  
  /*4th line*/
  btn_move_down = gnome_stock_button(GNOME_STOCK_BUTTON_DOWN);
  gtk_widget_set_sensitive(GTK_WIDGET(btn_move_down), FALSE);
  btn_move_up = gnome_stock_button(GNOME_STOCK_BUTTON_UP); 
  gtk_widget_set_sensitive(GTK_WIDGET(btn_move_up), FALSE);

  gtk_table_attach(GTK_TABLE(table), btn_move_up, 4, 5, 3, 4,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);

  gtk_table_set_row_spacing(GTK_TABLE(table), 3, GNOME_PAD_BIG + GNOME_PAD_BIG);
  gtk_table_set_row_spacing(GTK_TABLE(table), 4, GNOME_PAD_BIG + GNOME_PAD_BIG);
  gtk_table_set_row_spacing(GTK_TABLE(table), 5, GNOME_PAD_BIG + GNOME_PAD_BIG);
  /*  gtk_table_set_row_spacing(GTK_TABLE(table), 6, GNOME_PAD_BIG + GNOME_PAD_BIG); */
  
  gtk_table_attach(GTK_TABLE(table), btn_move_down, 4, 5, 6, 7,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);

  scroll_win = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_win),
				 GTK_POLICY_AUTOMATIC,
				 GTK_POLICY_ALWAYS);
  gtk_container_set_border_width(GTK_CONTAINER(scroll_win), 1);
  
  clist = gtk_clist_new_with_titles(3, col_titles);
  gtk_clist_set_shadow_type(GTK_CLIST(clist), GTK_SHADOW_IN);
  gtk_clist_set_column_auto_resize (GTK_CLIST(clist), 0, TRUE);
  
  /*   gtk_clist_set_column_width(GTK_CLIST(clist), 0, 75);
       gtk_clist_set_column_width(GTK_CLIST(clist), 1, 25); */
  
  /*  gtk_clist_column_titles_passive(GTK_CLIST(clist));*/
  gtk_clist_set_selection_mode(GTK_CLIST(clist), GTK_SELECTION_SINGLE);
  
/*    printf("count: %d\n", count_mailboxes()); */
  
  for (i = 0; i < gbox_mailbox_list_count(copy_list); i++) {
    row[0] = walk->nickname;
    g_snprintf(buf, sizeof(buf), "%d", walk->interval / 1000);
    row[1] = g_strdup(buf);
    g_snprintf(buf, sizeof(buf), "%d", walk->priority);
    row[2] = g_strdup(buf);
    gtk_clist_append(GTK_CLIST(clist), row);
    walk = walk->next;
  }
  
  gtk_widget_show(clist);
  gtk_container_add(GTK_CONTAINER(scroll_win), clist);
  
  gtk_table_attach(GTK_TABLE(table), scroll_win, 0, 4, 3, 7, 
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   0, 0);
  
  /*box_add = gtk_button_new_with_label(_("Add"));*/
  box_add = gnome_pixmap_button(GTK_WIDGET(gnome_stock_new_with_icon(GNOME_STOCK_PIXMAP_ADD)), _("Add"));
  gtk_table_attach(GTK_TABLE(table), box_add, 0, 1, 7, 8,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  /*  box_remove = gtk_button_new_with_label(_("Remove"));*/
  box_remove = gnome_pixmap_button(GTK_WIDGET(gnome_stock_new_with_icon(GNOME_STOCK_PIXMAP_REMOVE)), _("Remove"));
  gtk_table_attach(GTK_TABLE(table), box_remove, 1, 2, 7, 8,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  gtk_widget_set_sensitive(GTK_WIDGET(box_remove), FALSE);
  
  /*box_edit = gtk_button_new_with_label(_("Edit"));*/
  box_edit = gnome_pixmap_button(GTK_WIDGET(gnome_stock_new_with_icon(GNOME_STOCK_PIXMAP_PREFERENCES)), _("Edit"));
  gtk_table_attach(GTK_TABLE(table), box_edit, 2, 3, 7, 8,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  gtk_widget_set_sensitive(GTK_WIDGET(box_edit), FALSE);
  
  /*  box_copy = gtk_button_new_with_label(_("Copy"));*/
  box_copy = gnome_pixmap_button(GTK_WIDGET(gnome_stock_new_with_icon(GNOME_STOCK_PIXMAP_COPY)), _("Copy"));
  gtk_table_attach(GTK_TABLE(table), box_copy, 3, 4, 7, 8,
		   GTK_FILL | GTK_EXPAND, 
		   GTK_FILL | GTK_EXPAND, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  gtk_widget_set_sensitive(GTK_WIDGET(box_copy), FALSE);

  /*  gtk_signal_connect(GTK_OBJECT(btn_mailprog), "clicked",
      GTK_SIGNAL_FUNC(select_mailprog), mailprog);*/
  
  /* show table */
  
  gtk_widget_show_all(table);
  
  return table;
}

GtkWidget *create_page_prio() {
  /*  GtkWidget* btn_no_mail;
      GtkWidget* btn_new_mail; */
  GtkWidget *table;
  GtkWidget *label;
  GtkWidget *box;
  GtkWidget *t;
  gchar      buf[32];
  int        i;
  
  table = gtk_table_new(8, 4, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table), GNOME_PAD_SMALL);
  
  /*  first line */
  label = gtk_label_new(_("\"No Mail\"-Image:"));
  gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 0, 1, 
		   GTK_EXPAND | GTK_FILL, 
		   GTK_EXPAND | GTK_FILL, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  /*  current_icons.no_mail = gtk_button_new();
      current_icons.pix_no_mail = gtk_pixmap_new(applet->no_email_pixmap, applet->no_email_mask);
      gtk_container_add(GTK_CONTAINER(current_icons.no_mail), current_icons.pix_no_mail);*/
  
  current_icons.no_mail = gnome_icon_entry_new("no_mail", _("Select Icon"));
  gnome_icon_entry_set_icon(GNOME_ICON_ENTRY(current_icons.no_mail), current_icons.file_no_mail);
  t = gnome_icon_entry_gtk_entry (GNOME_ICON_ENTRY (current_icons.no_mail));
  gtk_table_attach(GTK_TABLE(table), current_icons.no_mail, 1, 2, 0, 1,
		   GTK_FILL, GTK_FILL, 
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  gtk_signal_connect_object_while_alive (GTK_OBJECT (t), "changed",
					 GTK_SIGNAL_FUNC(text_changed), 
					 GTK_OBJECT(prop_box));
  
  /* second line */
  label = gtk_label_new(_("\"New Mail\"-Images:"));
  gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 1, 2,
		   GTK_EXPAND | GTK_FILL,
		   GTK_EXPAND | GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  for (i = 0; i < COUNT_PRIORITY; i++) {
    box = gtk_hbox_new (0, 0);
    g_snprintf(buf, sizeof(buf), "%d:", i);
    label = gtk_label_new(buf);
    current_icons.new_mail[i] = gnome_icon_entry_new("bla", _("Select Icon"));
    t = gnome_icon_entry_gtk_entry (GNOME_ICON_ENTRY (current_icons.new_mail[i]));
    gnome_icon_entry_set_icon(GNOME_ICON_ENTRY(current_icons.new_mail[i]), current_icons.file_new_mail[i]);
    gtk_signal_connect_object_while_alive (GTK_OBJECT (t), "changed",
					   GTK_SIGNAL_FUNC(text_changed), 
					   GTK_OBJECT(prop_box));
    gtk_box_pack_start(GTK_BOX(box), GTK_WIDGET(label), TRUE, TRUE, GNOME_PAD_SMALL);
    gtk_box_pack_start(GTK_BOX(box), GTK_WIDGET(current_icons.new_mail[i]), FALSE, FALSE, GNOME_PAD_SMALL);
    gtk_table_attach(GTK_TABLE(table), box, i+1, i+2, 1, 2,
		     0,
		     0,
		     GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  }
  
  /* show table */
  gtk_widget_show_all(table);
   
  return table;
}

GtkWidget *
create_page_misc()
{
  GtkWidget *table;
  GList     *list = NULL;
  GtkWidget *label;
  
  table = gtk_table_new(4, 2, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table), GNOME_PAD_SMALL);
  
  /*  first line */
  chk_beep = gtk_check_button_new_with_label(_("beep on new mail"));
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chk_beep), applet->style_beep);
  /*  gtk_misc_set_alignment(GTK_MISC(chk_beep), 0.0, 0.5);*/
  gtk_table_attach(GTK_TABLE(table), chk_beep, 0, 1, 0, 1,
		   GTK_FILL,
		   GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  

  /*  second line */
  chk_relief = gtk_check_button_new_with_label(_("use flat style for applet"));
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chk_relief), applet->style_relief);
  /*gtk_misc_set_alignment(GTK_MISC(chk_relief), 0.0, 0.5);*/
  gtk_table_attach(GTK_TABLE(table), chk_relief, 0, 1, 1, 2,
		   GTK_FILL,
		   GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);

  /*  third line */
  /*  box = gtk_hbox_new(0,0);*/
  chk_tooltip = gtk_check_button_new_with_label(_("show tooltip"));

  gtk_table_attach(GTK_TABLE(table), chk_tooltip, 0, 1, 2, 3,
		   GTK_FILL,
		   GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  cbo_tooltip_type = gtk_combo_new();

  list = g_list_append(list, _(tooltip_types[0]));
  list = g_list_append(list, _(tooltip_types[1]));
  list = g_list_append(list, _(tooltip_types[2]));
  list = g_list_append(list, _(tooltip_types[3]));

  gtk_combo_set_popdown_strings(GTK_COMBO(cbo_tooltip_type), list); 
  gtk_combo_set_use_arrows(GTK_COMBO(cbo_tooltip_type), 3);
  /*  gtk_combo_set_value_in_list(GTK_COMBO(cbo_tooltip_type), */
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chk_tooltip), applet->show_tooltip);
  switch (applet->style_tooltip) {
  case 0:
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_tooltip_type)->entry), _(tooltip_types[0])); break;
  case 1:
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_tooltip_type)->entry), _(tooltip_types[1])); break;
  case 2:
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_tooltip_type)->entry), _(tooltip_types[2]));break;
  case 3:
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_tooltip_type)->entry), _(tooltip_types[3]));
  }

  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(cbo_tooltip_type)->entry), FALSE); 
  
  gtk_widget_set_sensitive(GTK_WIDGET(cbo_tooltip_type), 
			   gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_tooltip)));

/*    gtk_widget_set_sensitive(GTK_WIDGET(GTK_COMBO(cbo_tooltip_type)->entry), FALSE); */

  /*  gtk_box_pack_start_defaults(GTK_BOX(box), chk_tooltip);
      gtk_box_pack_start_defaults(GTK_BOX(box), cbo_tooltip_type);*/
  
  gtk_table_attach(GTK_TABLE(table), cbo_tooltip_type, 1, 2, 2, 3,
		   GTK_FILL,
		   GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);


  /*  fourth line */
  label = gtk_label_new(_("relative position"));
  gtk_misc_set_alignment(GTK_MISC(label), 0.25, 0.5);
  gtk_widget_show(label);
  
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 3, 4,
		   GTK_FILL,
		   GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);
  
  cbo_tooltip_pos = gtk_combo_new();
  g_list_free(list); list = NULL;
  
  list = g_list_append(list,_(tooltip_pos[0])); 
  list = g_list_append(list,_(tooltip_pos[1]));  
  list = g_list_append(list,_(tooltip_pos[2]));
  list = g_list_append(list,_(tooltip_pos[3]));

  gtk_combo_set_popdown_strings(GTK_COMBO(cbo_tooltip_pos), list); 
  gtk_combo_set_use_arrows(GTK_COMBO(cbo_tooltip_pos), 3);
  /*  gtk_combo_set_value_in_list(GTK_COMBO(cbo_tooltip_type), */

  switch (applet->pos_tooltip) {
  case 0:
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_tooltip_pos)->entry), _(tooltip_pos[0])); break;
  case 1:
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_tooltip_pos)->entry), _(tooltip_pos[1])); break;
  case 2:
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_tooltip_pos)->entry), _(tooltip_pos[2]));break;
  case 3:
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cbo_tooltip_pos)->entry), _(tooltip_pos[3]));
  }

  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(cbo_tooltip_pos)->entry), FALSE); 
  
  gtk_widget_set_sensitive(GTK_WIDGET(cbo_tooltip_pos), 
			   gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chk_tooltip)));

/*    gtk_widget_set_sensitive(GTK_WIDGET(GTK_COMBO(cbo_tooltip_pos)->entry), FALSE); */

  /*  gtk_box_pack_start_defaults(GTK_BOX(box), cbo_tooltip_pos);*/
  
  gtk_table_attach(GTK_TABLE(table), cbo_tooltip_pos, 1, 2, 3, 4,
		   GTK_FILL,
		   GTK_FILL,
		   GNOME_PAD_SMALL, GNOME_PAD_SMALL);


  /* setting up signal-handler */
  gtk_signal_connect_object_while_alive (GTK_OBJECT (chk_beep), "toggled",
					 GTK_SIGNAL_FUNC(text_changed), 
					 GTK_OBJECT(prop_box));
  gtk_signal_connect_object_while_alive (GTK_OBJECT (chk_relief), "toggled",
					 GTK_SIGNAL_FUNC(text_changed), 
					 GTK_OBJECT(prop_box));
  gtk_signal_connect_object_while_alive (GTK_OBJECT (chk_tooltip), "toggled",
					 GTK_SIGNAL_FUNC(text_changed), 
					 GTK_OBJECT(prop_box));
  gtk_signal_connect_object_while_alive (GTK_OBJECT (GTK_COMBO(cbo_tooltip_type)->entry), "changed",
					 GTK_SIGNAL_FUNC(text_changed), 
					 GTK_OBJECT(prop_box));
  gtk_signal_connect_object_while_alive (GTK_OBJECT (GTK_COMBO(cbo_tooltip_pos)->entry), "changed",
					 GTK_SIGNAL_FUNC(text_changed), 
					 GTK_OBJECT(prop_box));

  /* show table */
  gtk_widget_show_all(table);

  return table;
}

void mail_items(AppletWidget *app, gpointer data){}


void
applet_properties(AppletWidget *app, gpointer data)
{
  GtkWidget *page;
  int       i;
  
  /* check if property-box is open */
	if (applet->prop_box_active)
		return;
	else
		applet->prop_box_active = TRUE;

	/* stop watch mailboxes; */
  stop_timer();
  edit_mode = FALSE;
  copy_list = gbox_mailbox_list_copy(mb_list);
  
  prop_box = gnome_property_box_new();
   
  gtk_window_set_title(GTK_WINDOW(prop_box), _("gbox properties"));

  /* copy current icon selection */
  current_icons.file_no_mail = g_strdup(applet->no_mail_pix);
  for (i = 0; i < COUNT_PRIORITY; i++)
    current_icons.file_new_mail[i] = g_strdup(applet->new_mail_pix[i]);
    
  page = create_page_global();
  gnome_property_box_append_page(GNOME_PROPERTY_BOX(prop_box), page,
				 gtk_label_new(_("Mailboxes")));

  page = create_page_prio();
  gnome_property_box_append_page(GNOME_PROPERTY_BOX(prop_box), page,
				 gtk_label_new(_("Icons")));

  page = create_page_misc();
  gnome_property_box_append_page(GNOME_PROPERTY_BOX(prop_box), page,
				 gtk_label_new(_("Misc")));

  gtk_signal_connect(GTK_OBJECT(mailprog), "changed",
		     GTK_SIGNAL_FUNC(text_changed), prop_box);
  
  gtk_signal_connect(GTK_OBJECT(clist), "select_row",
		     GTK_SIGNAL_FUNC(box_select_cb), prop_box);
  
  gtk_signal_connect(GTK_OBJECT(box_edit), "clicked",
		     GTK_SIGNAL_FUNC(edit_box_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(box_add), "clicked",
		     GTK_SIGNAL_FUNC(add_box_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(box_remove), "clicked",
		     GTK_SIGNAL_FUNC(remove_box_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(box_copy), "clicked",
		     GTK_SIGNAL_FUNC(copy_box_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(btn_move_down), "clicked",
		     GTK_SIGNAL_FUNC(move_down_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(btn_move_up), "clicked",
		     GTK_SIGNAL_FUNC(move_up_cb), NULL);
  
  gtk_signal_connect(GTK_OBJECT(prop_box), "apply",
		     GTK_SIGNAL_FUNC(apply_prop_cb), NULL);

  gtk_signal_connect(GTK_OBJECT(prop_box), "close",
		     GTK_SIGNAL_FUNC(close_prop_cb), NULL);

  gtk_widget_show(prop_box);
}
